
package de.ivu.elect.presentation.dokumente.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;

import de.ivu.elect.business.dokumente.boundary.DokumentVorlageSearchParameters;
import de.ivu.elect.business.dokumente.entity.DokumentVorlageConstants;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.dokumente.DokumentVorlageSearchView;
import de.ivu.elect.presentation.dokumente.exchange.DokumentBulkExportSearchEntry;

public class DokumentBulkExportSearchEntryDokumentVorlageSearchAction extends AbstractDokumentBulkExportSearchEntryDokumentVorlageEditAction {

  private static final long serialVersionUID = 1L;

  @View
  @Inject
  private transient DokumentVorlageSearchView dokumentVorlageSearchView;

  public DokumentBulkExportSearchEntryDokumentVorlageSearchAction() {
    super();
  }

  @Override
  public boolean hasPrincipalRequiredPermission() {
    return super.hasPrincipalRequiredPermission() && principal.hasUseCasePermission(UseCasePermission.DOKUMENT_VORLAGE_SEARCH);
  }

  @Override
  protected boolean isDisabledInternal(@Nonnull DokumentBulkExportSearchEntry dokumentBulkExportSearchEntry) {
    return super.isDisabledInternal(dokumentBulkExportSearchEntry) || dokumentBulkExportSearchEntry.getDokumentVorlagenRequiredAnzahl() < 2;
  }

  @Override
  protected String doIt(DokumentBulkExportSearchEntry dokumentBulkExportSearchEntry) {
    DokumentVorlageSearchParameters dokumentVorlageSearchParameters = dokumentVorlageSearchView.getSearchParameters();
    dokumentVorlageSearchParameters.setDokumentVorlageArt(null);
    dokumentVorlageSearchParameters.setDokumentVorlageAnlageArt(null);
    dokumentVorlageSearchParameters.setName(null);
    dokumentVorlageSearchParameters.setVersionsnummer(null);

    if (dokumentBulkExportSearchEntry.getDokumentVorlagenRequiredAnzahl() > 1) {
      dokumentVorlageSearchParameters.setDokumentVorlageArt(dokumentBulkExportSearchEntry.getDokumentVorlageArt());

      return DokumentVorlageSearchView.VIEW_ID;
    }

    return null;
  }

  @Override
  protected String getLocalizedLabel() {
    return getMessage(getLabelKey(), getMessage(DokumentVorlageConstants.MESSAGE_KEY_ENTITY_MEHRZAHL));
  }
}
